
#include <nokix/all.h>

/********************************************************
** chooser.c
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2.1 of the License, or
** (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
********************************************************/

#include "global.h"

extern rexx_uint confid_main;
extern rexx_uint confid_anim;
extern rexx_uint num_of_anims;

/**************************************************************************************/

static void next_frame(void)
{
 send_ui_message(OMSG_NEXT_FRAME|MSG_1P,data->cur);
}

/* UI messages dispatcher */
extern rexx_uint dispatcher_chooser_id; /* dispatcher's call id */
rexx("dispatcher_chooser_id=add_5e0_id(dispatcher_chooser)"); /* auto creation of the id */

ULONG dispatcher_chooser(ULONG msg)
{
 switch(msg)
 {
  case MSG_D_INIT:
  {
   data=malloc(sizeof(struct data));
   data->cur=own_get_config(confid_anim);
   if(data->cur>=num_of_anims) data->cur=0;
   data->restart=TRUE;
   send_message(OMSG_NEXT_FRAME|MSG_1P,data->cur);
   freegfx_open();
   freegfx_draw(); // data->f uninitialized ??!!

   msg=MSG_R_STAY;
   break;
  }
  case MSG_D_QUIT:
  case MSG_D_QUIT_NOW:
  {
   freegfx_close();
   own_timer_abort(next_frame);
   free(data);
   stop_gran_vals();

   if(msg==MSG_D_QUIT) msg=MSG_R_QUIT;
   break;
  }
  case OMSG_NEXT_FRAME:
  {
   if(msg_argv[0]==data->cur)
   {
	if(data->restart)
	{
	 data->f=anims[data->cur].anim;
	 data->restart=FALSE;
	 freegfx_begin(TRUE); /* clear screen */
	 freegfx_end(FALSE);
    play_gran_vals();
	}
    else data->f++;
    if(data->f->bitmap)
    {
     own_timer_start(next_frame,TT_FUNCTION,data->f->time);
     freegfx_draw(); /* draw next frame */
    }
    else /* end of anim, wait a little and play it again */
    {
	 freegfx_begin(TRUE); /* clear screen */
	 freegfx_end(FALSE);
	 data->restart=TRUE;
     own_timer_start(next_frame,TT_FUNCTION,150);
	}
   }
   msg=MSG_NOP;
   break;
  }
  case MSG_KEY_UP:
  case MSG_KEY_DOWN:
  {
   own_timer_abort(next_frame);

   if(msg==MSG_KEY_UP) /* prevoius anim */
   {
    if(data->cur==0) data->cur=num_of_anims-1;
    else data->cur--;
   }
   else /* next anim */
   {
    if(data->cur==num_of_anims-1) data->cur=0;
    else data->cur++;
   }

   data->restart=TRUE;
   send_message(OMSG_NEXT_FRAME|MSG_1P,data->cur);

   msg=MSG_NOP;
   break;
  }
  case MSG_KEY_ACTION1:
  {
   own_set_config(confid_anim,data->cur);
   own_set_config(confid_main,1);
   send_message(MSG_REQUEST_QUIT);
   send_message(MSG_DISPLAY_MESSAGE|MSG_2P,DMI_DONE,str_done);
   msg=MSG_NOP;
   //break;
  }
 }
 return msg;
}

