
#include <nokix/all.h>

/********************************************************
** welcome_anim.c
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2.1 of the License, or
** (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
********************************************************/

#include "global.h"

extern rexx_uint id_system_welcome;
extern rexx_uint confid_main;
extern rexx_uint confid_anim;
extern rexx_uint num_of_anims;

static const ULONG timer=OMSG_NEXT_FRAME;

/**************************************************************************************/

ULONG dispatcher_welcome_anim(ULONG msg)
{
 switch(msg)
 {
  case MSG_SHOW_PENDING_DISP_MSGS: /* end of "code accepted" window */
  {
   send_ui_message(OMSG_NEXT_FRAME|MSG_1P);
   break;
  }
  case MSG_D_INIT:
  {
   UBYTE n=0;

   if(own_get_config(confid_main))
   {
    if(confid_anim!=CONFID_NONE) n=own_get_config(confid_anim);
    if(n<num_of_anims)
    {
	 data=malloc(sizeof(struct data));
     data->f=anims[n].anim;
	 data->cur=n;

     /* tests if we are visible, ie. no "code accepted" window is displayed */
     freegfx_open();
	 freegfx_begin(TRUE);
	 if(freegfx_end(TRUE)) send_ui_message(OMSG_NEXT_FRAME|MSG_1P); /* yes, we are visible */

	 msg=MSG_R_STAY;
    }
   }
   else	send_message(MSG_START_HANDLER|MSG_1P,id_system_welcome);
   break;
  }
  case MSG_KEYPRESS:
  case MSG_D_QUIT:
  {
   own_timer_abort(&timer);

   freegfx_close();
   free(data);
   stop_gran_vals();
   send_message(0x4588,0xff); /* this allows the user to set time if needed */
   
   msg=MSG_R_QUIT;
   break;
  }
  case OMSG_NEXT_FRAME:
  {
   if(msg_argc==0) data->f++;
   else play_gran_vals();
   if(data->f->bitmap)
   {
    own_timer_start(&timer,TT_MESSAGE,data->f->time);
    freegfx_draw();
    
	msg=MSG_NOP;
   }
   else
   {
    freegfx_close();
    free(data);
   stop_gran_vals();
	send_message(MSG_START_HANDLER|MSG_1P,id_system_welcome); /* we're done, now run system welcomes */
    
	msg=MSG_R_QUIT;
   }
   
   //break;
  }
 }
 return msg;
}
